<template>
  <div class="modal-mask">
    <div class="modal-wrapper">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">
              {{
                selected != null && editable != true
                  ? "View Booking"
                  : selected != null && editable == true
                  ? "Edit Booking"
                  : "Add Booking"
              }}
            </h5>
            <button
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true" @click="$emit('closed')">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="fluid-container">
              <div class="d-flex flex-wrap"></div>
              <form>
                <div class="form-group">
                  <div v-if="date && !selectedClient">
                    <label for="type"
                      >Date: {{ new Date(date).toDateString() }}</label
                    >
                  </div>
                  <div v-else>
                    <label>Date</label>
                    <input
                      :disabled="disabled"
                      type="date"
                      class="form-control"
                      v-model="date"
                      :min="new Date().toISOString().split('T')[0]"
                    />
                  </div>
                </div>
                <div class="form-group">
                  <label for="type">Title </label>
                  <input
                    :disabled="disabled"
                    class="form-control"
                    type="text"
                    v-model="title"
                  />
                </div>
                <div class="form-group" v-if="user.role === 'Admin'">
                  <div v-if="selectedTrainer == null && trainers.length > 0">
                    <label for="type">Trainer </label>
                    <select
                      :disabled="disabled"
                      class="custom-select"
                      required
                      id="client-select"
                      @change="getTrainersClients"
                      v-model="trainerId"
                    >
                      <option disabled value="">Trainer Name</option>
                      <option
                        v-for="trainer in trainers"
                        :key="trainer.trainerId"
                        :value="trainer.trainerId"
                      >
                        {{ trainer.firstName + " " + trainer.lastName }}
                      </option>
                    </select>
                  </div>
                  <div v-else-if="selectedTrainer != null">
                    <label>Trainer </label>
                    <input
                      class="form-control"
                      type="text"
                      disabled
                      :value="
                        selectedTrainer.firstName +
                        ' ' +
                        selectedTrainer.lastName
                      "
                    />
                  </div>
                  <div v-else>
                    <label>No Trainers Found</label>
                  </div>
                </div>
                <div class="form-group">
                  <div v-if="clients.length > 0">
                    <label for="type">Client </label>
                    <select
                      :disabled="disabled"
                      class="custom-select"
                      required
                      id="client-select"
                      v-model="clientId"
                    >
                      <option disabled value="">Client Name</option>
                      <option
                        v-for="client in clients"
                        :key="client.clientId"
                        :value="client.clientId"
                      >
                        {{ client.firstName + " " + client.lastName }}
                      </option>
                    </select>
                  </div>
                  <div v-else-if="selectedClient">
                    <label>Client </label>
                    <input
                      class="form-control"
                      type="text"
                      disabled
                      :value="
                        selectedClient.firstName + ' ' + selectedClient.lastName
                      "
                    />
                  </div>
                  <div v-else>
                    <label>No Clients with sessions</label>
                  </div>
                </div>
                <div class="form-group">
                  <div v-if="venues.length > 0">
                    <label for="type">Venue</label>
                    <select
                      :disabled="disabled"
                      class="custom-select"
                      required
                      id="venue-select"
                      v-model="venueId"
                    >
                      <option disabled value="">Venue</option>
                      <option
                        v-for="v in venues"
                        :key="v.venueId"
                        :value="v.venueId"
                      >
                        {{ v.address }}
                      </option>
                    </select>
                  </div>
                  <div v-else>
                    <label>No Venues Found</label>
                  </div>
                </div>
                <div class="form-group">
                  <label for="type">Time</label>
                  <input
                    :disabled="disabled"
                    class="form-control"
                    type="time"
                    v-model="time"
                  />
                </div>
                <div v-if="selected != null">
                  <div class="form-group">
                    <label for="type">Status</label>
                    <select
                      :disabled="disabled"
                      class="form-control"
                      type="time"
                      v-model="status"
                    >
                      <option value="0">Booked</option>
                      <option value="1">Completed</option>
                      <option value="2">Cancelled</option>
                    </select>
                  </div>
                </div>

                <div class="modal-footer">
                  <div v-if="selected == null">
                    <div
                      v-if="
                        (clients.length != 0 && venues.length != 0) ||
                        (selectedClient && date)
                      "
                    >
                      <button
                        type="submit"
                        class="btn btn-primary"
                        @click.prevent="submitForm"
                      >
                        Submit
                      </button>
                    </div>
                  </div>
                  <div v-else-if="selected != null && editable">
                    <div v-if="disabled == true">
                      <button
                        type="submit"
                        class="btn btn-secondary"
                        @click.prevent="enableEdit"
                      >
                        Edit Booking
                      </button>
                    </div>
                    <div v-else>
                      <button
                        type="submit"
                        class="btn btn-primary"
                        @click.prevent="updateBooking"
                      >
                        Submit Changes
                      </button>
                    </div>
                  </div>

                  <button class="btn btn-secondary" @click="$emit('closed')">
                    Close
                  </button>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import trainer from "../../controllers/trainer.controller";
import venue from "../../controllers/venue.controller";
import booking from "../../controllers/booking.controller";
import client from "../../controllers/client.controller";

import swal from "sweetalert2";
import time from "../../utils/time";
export default {
  name: "BookingModal",
  props: ["date", "selected", "user"],
  data: function () {
    return {
      clients: [],
      trainers: [],
      venues: [],
      clientId: this.selected != null ? this.selected.clientId : null,
      trainerId: this.selected != null ? this.selected.trainerId : null,
      selectedClient: null,
      selectedTrainer: null,
      venueId: this.selected != null ? this.selected.venueId : null,
      bookingId: this.selected != null ? this.selected.bookingId : null,
      time: this.selected != null ? this.selected.start.substring(11, 16) : "",
      status: this.selected != null ? this.selected.status : null,
      title: this.selected != null ? this.selected.name : "",
      disabled: this.selected != null ? true : false,
      editable:
        this.selected != null &&
        this.selected.status == 0 &&
        this.user.role != "Client"
          ? true
          : this.selected != null && this.user.role == "Admin"
          ? true
          : false,
    };
  },
  methods: {
    async submitForm() {
      let sessionTime = new Date(
        time.getLocalISO(this.date, this.time)
      ).toJSON();
      try {
        let info = {
          trainerId:
            this.user.role != "Admin" ? this.user.trainerId : this.trainerId,
          clientId: this.clientId,
          venueId: this.venueId,
          bookingDate: new Date().toJSON(),
          sessionDate: sessionTime,
          status: 0,
          description: this.title,
        };
        if (this.selectedClient) {
          info.clientId = this.selectedClient.clientId;
        }
        let response = await booking.postBooking(info);

        if (response.status === 201) {
          this.$emit("closed");
          swal.fire({
            icon: "success",
            title: `Booking has been added`,
            showConfirmButton: false,
            timer: 2000,
          });

          this.$emit("populate");
        }
      } catch (e) {
        this.$emit("closed");
        swal.fire("Oops something went wrong");
      }
    },
    async enableEdit() {
      this.disabled = false;
    },

    async updateBooking() {
      let sessionTime = new Date(
        time.getLocalISO(this.date, this.time)
      ).toJSON();
      try {
        let updatedBooking = {
          bookingId: this.bookingId,
          trainerId:
            this.user.role != "Admin" ? this.user.trainerId : this.trainerId,
          clientId: this.clientId,
          venueId: this.venueId,
          bookingDate: new Date().toJSON(),
          sessionDate: sessionTime,
          status: this.status,
          description: this.title,
        };
        let response = await booking.updateBooking(updatedBooking);
        if (response.status === 204) {
          this.$emit("closed");
          swal.fire({
            icon: "success",
            title: `Booking edited successfully`,
            showConfirmButton: false,
            timer: 2000,
          });
          this.$emit("populate");
        }
      } catch (e) {
        this.$emit("closed");
        swal.fire("Oops something went wrong");
      }
    },
    async getTrainersClients() {
      this.clients = await trainer.getTrainersClients(this.trainerId);
    },
  },
  async created() {
    this.venues = await (await venue.getActiveVenues()).data;
    if (this.selected) {
      this.selectedClient = await (
        await client.getClient(this.selected.clientId)
      ).data;
      this.trainers = await trainer.getTrainers();
      this.selectedTrainer = this.trainers.find((trainer) => {
        return trainer.trainerId === this.selected.trainerId;
      });
      return;
    }
    if (this.user.role === "Trainer") {
      const clients = await trainer.getTrainersClients(this.user.trainerId);

      this.clients = clients.filter((client) => {
        console.log(client);
        return client.sessions > 0;
      });
    } else {
      this.trainers = await trainer.getTrainers();

      this.clients = [];
    }
  },
};
</script>

<style>
.modal-mask {
  position: fixed;
  z-index: 9998;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5);
  display: table;
  transition: opacity 0.3s ease;
}

.modal-wrapper {
  display: table-cell;
  vertical-align: middle;
}
</style>